//Nexus and Rykuta Gamemodifications - Answering Machine

$NARGAM_Version = "2.1 FULL";

package NARGAM
{
	function RTBCC_Socket::online(%this, %text)
	{
		parent::online(%this, %text);

		if($NARGAM_Status !$= "online" && $NARGAM::Message[$NARGAM_Status] !$= "" && $NARGAM::Enabled)
		{
			%text = nexttoken(%text, header, "\""); //creates %header variable (witchcraft)

			if(%header $= "<message from=")
			{
				%text = nexttoken(%text, id, "\""); //does same to %id (heresy I say!)
				%text = nexttoken(%text, to, "\"");
				%text = nexttoken(%text, check, "\"");

				if(%check == getnumkeyid())
					RTBCC_Socket.sendmessage(%id, $NARGAM::Message[$NARGAM_Status]);
			}
		}
	}

	function RTB_ConnectClient::setStatus(%this, %status, %update)
	{
		parent::setStatus(%this, %status, %update);
		$NARGAM_Status = %status;
	}

	function RTB_Options::onwake(%this, %idk)
	{
		parent::onwake(%this, %idk);
		RTB_Overlay.push(NARGAM_Window);
		NARGAM_awaybox.settext($NARGAM::Messageaway);
		NARGAM_busybox.settext($NARGAM::Messagebusy);
		NARGAM_hiddenbox.settext($NARGAM::Messagehidden);
		NARGAM_enabledoption.setvalue($NARGAM::Enabled);
		NARGAM_Versionbutton.settext($NARGAM_Version);

		if(!$NARGAM_Checked)
		{
			$NARGAM_Checked = 1;
			NARGAM_versioncheck();
		}
		NARGAM_window.setvisible(RTB_Options.isvisible());
	}

	function RTB_Options::onsleep(%this, %idk)
	{
		parent::onsleep(%this, %idk);
		$NARGAM::Messageaway = NARGAM_awaybox.getvalue();
		$NARGAM::Messagebusy = NARGAM_busybox.getvalue();
		$NARGAM::Messagehidden = NARGAM_hiddenbox.getvalue();
		$NARGAM::Enabled = NARGAM_enabledoption.getvalue();
		export("$NARGAM::*", "config/client/AnsweringMachine/prefs.cs");
		RTB_Overlay.pop(NARGAM_Window);
	}
};
activatepackage(NARGAM);

//just because of rtb errors
function NARGAM_Window::onwake(%this, %idk)
{
	//don't error omg
}

function NARGAM_Window::onsleep(%this, %idk)
{
	//rawr
}

if(isobject(NARGAM_Window))
	NARGAM_Window.delete();
exec("./NARGAMGUI.GUI");
RTB_Overlay.add(NARGAM_Window);
NARGAM_Window.setvisible(0);
$NARGAM::Messageaway = "I am not available to answer you right now, please try again later.";
$NARGAM::Messagebusy = "I don't want to be bothered right now, please stick your keyboard up your butt.";
$NARGAM::Messagehidden = "";
$NARGAM::Enabled = 1;

if(isfile("config/client/AnsweringMachine/prefs.cs"))
	exec("config/client/AnsweringMachine/prefs.cs");

//version check system
function NARGAM_versioncheck(%x)
{
	if(!%x && isfile("./rtbinfo.txt") && isfile("add-ons/system_returntoblockland/client.cs"))
		return;
	$NARGAM_manualconnect = %x;

	if(isobject(NARGAM_Downloader))
		NARGAM_Downloader.delete();

	new tcpobject(NARGAM_Downloader);
	$NARGAM_downloadphase = 0;
	NARGAM_Downloader.connect("forum.blockland.us:80");
}

function NARGAM_Downloader::onConnected(%this)
{
	if($NARGAM_downloadphase == 0)
	{
		//forum.blockland.us/index.php?topic=161834.720
		%req = "GET /index.php?topic=161834.720 HTTP/1.0\nHost: forum.blockland.us\n\n";
		%this.send(%req);
	}
	else
	{
		%req = "GET /index.php?action=dlattach;topic=161834.0;attach="@ $NARGAM_versionfile SPC"HTTP/1.0\nHost: forum.blockland.us\n\n";
		%this.send(%req);
	}
}

function NARGAM_Downloader::onConnectFailed(%this)
{
	if($NARGAM_manualconnect)
		messageboxok("Attention!", "Unable to connect to the online version information.");
}

function NARGAM_Downloader::onDisconnect(%this)
{
	if(!$NARGAM_connected)
	{
		if($NARGAM_manualconnect)
			messageboxok("Attention!", "Unable to connect to the online version information.");
	}
	else
		$NARGAM_connected = "";
}

function NARGAM_Downloader::onLine(%this, %line)
{
	if($NARGAM_downloadphase == 0)
	{
		if(strpos(%line, "Versions.txt") > -1)
		{
			%subline = "http://forum.blockland.us/index.php?action=dlattach;topic=161834.0;attach=";
			$NARGAM_versionfile = getsubstr(%line, strpos(%line, %subline)+strlen(%subline), strpos(%line, "\">")-(strpos(%line, %subline)+strlen(%subline)));

			if(NARGAM_isint($NARGAM_versionfile))
			{
				$NARGAM_connected = 1;
				NARGAM_Downloader.disconnect();
				$NARGAM_downloadphase = 1;
				NARGAM_Downloader.connect("forum.blockland.us:80");
			}
			else
				NARGAM_Downloader.disconnect();
		}
	}
	else
	{
		if(getsubstr(%line, 0, 25) $= "NARG MOD VERSION NARGAM: ")
		{
			$NARGAM_connected = 1;
			$NARGAM_availableversion = getsubstr(%line, 25, strlen(%line)-25);

			if($NARGAM_availableversion $= $NARGAM_Version)
				NARGAM_versionresult(1);
			else
				NARGAM_versionresult(0);
			NARGAM_Downloader.disconnect();
		}
	}
}

function NARGAM_versionresult(%x)
{
	if(%x)
	{
		if($NARGAM_manualconnect)
			messageboxok("Good News!", "Your Answering Machine mod is up to date.");
	}
	else
		messageboxok("Attention!", "There is a more current version of your Answering Machine Mod.\n\nYour Version: "@$NARGAM_version@"\n\nAvailable: "@$NARGAM_availableversion);
}

function NARGAM_isint(%x)
{
	if(%x $= mfloor(%x)) //also makes it sure it is a string
		return 1;
	return 0;
}
